#ifndef SIM_H
#define SIM_H

#define _POSIX_C_SOURCE 200112L

#include <stdint.h>

#include "romu.h"
#include "rtcproto.h"

#define ESC_RST "\033[0m"
#define ESC_BLD "\033[1m"

#define ESC_WHT "\033[0m"
#define ESC_RED "\033[31m"
#define ESC_GRN "\033[32m"
#define ESC_YEL "\033[33m"
#define ESC_BLU "\033[34m"
#define ESC_MAG "\033[35m"

typedef enum TrophCell
{
    TROPH_DEAD = 0,
    TROPH_AUTO,
    TROPH_HETE,
    TROPH_COUNT,
} TrophCell;

typedef enum TrophParams
{
    TROPH_AUTO_REPRO = 0,
    TROPH_AUTO_DEATH,
    TROPH_HETE_REPRO,
    TROPH_HETE_DEATH,
    TROPH_PARAM_COUNT,
} TrophsParams;

typedef struct Trophs
{
	int neigh[8][2];

	uint32_t romu_trio32[3];

	int width;
	uint8_t grid;
    int bytes;
	int off_comp;
    int off_old;
    int off_new;

	float params[TROPH_PARAM_COUNT];
    int hete_hunt;

    uint8_t* cells;
} Trophs;

void trophs_malloc(Trophs* trophs, int width);
void trophs_free(Trophs* trophs);
void trophs_initialize(Trophs* trophs, float params[TROPH_PARAM_COUNT]);
void trophs_show(Trophs* trophs);
void trophs_step(Trophs* trophs);
void trophs_random(Trophs* trophs);

#endif /* SIM_H */
